/* T}[ */
proc summary data=sugij.tran nway;
	class cust_id product;
	var sales;
	output out=sum1(keep=cust_id product sales) sum=;
run;

/* TRANSPOSEp̃f[^H */
proc sort data=sum1 out=sum2;
 by product;
run;
data sum2;
 set sum2;
 if _n_=1 then prodid=0;
 by product;retain;
 prodid=prodid;
 if first.product then prodid=prodid+1;
 output;
run;

/* TRANSPOSE */
proc sort data=sum2;
 by cust_id;
run;
proc transpose data=sum2
	out=sum3(drop=_NAME_ _LABEL_) prefix=prod;
 by cust_id;
 id prodid;
 idlabel product;
 var sales;
run;


/* lƍv̎Zo */
data sum4(drop=i);set sum3;
 array nvar _numeric_;
 do i=1 to dim(nvar);
  if nvar[i]=. then nvar[i]=0;
 end;
 total=sum(of prod1-prod16);
 format total yen15.0; label total='㍇v';
run;

/* w */
proc sort data=sugij.tran(keep=cust_id date) out=sum5;
 by cust_id date;
run;
data sum6(keep=cust_id time);
 set sum5;
 by cust_id ;retain;
 if first.cust_id then fst_date=date ;
 if last.cust_id then do;
    lst_date=date;
    time=lst_date-fst_date;
    label time='w';
    output;
 end; 
run;

/* RFMͥRZo */
data r(keep=cust_id r);
    set sugij.tran(keep=cust_id date) ;
    by CUST_ID;
    rename date=r;
    if last.cust_id then output;
run;quit;

/* RFMͥFZo */
/* Aɉ񔃂Ă1ƃJEg*/
data f(keep=cust_id f);
	set sugij.tran(keep=cust_id date);
	by cust_id;
	lag=date-lag1(date);
	if first.cust_id =1 then do;lag=0;f=1;end;
	if first.cust_id =0 and lag > 0 then f+1;
	if last.cust_id then output;
run;

/* RFMͥMZo */
proc summary data=sugij.tran(keep=cust_id sales) nway;
        class cust_id;
        var sales;
        output out=m(keep=cust_id m)sum=m;
run;quit;

/* RFM̒l|CgZo */
/* RFMꂼŜ̒lZo */
proc univariate data=r noprint;
   var r;
   output out=m_r median=m_r;
proc univariate data=f noprint;
   var f;
   output out=m_f median=m_f;    
proc univariate data=m noprint;
   var m;
   output out=m_m median=m_m;
run;    

data _null_;
	set m_r;
	call symput('m_r',m_r);
	set m_f;
	call symput('m_f',m_f);
	set m_m;
	call symput('m_m',m_m);
run;

/* RFM|Cgf[^̍쐬 */
data RFM(keep=cust_id r_point f_point m_point rfm_pnt);
	merge r f m;
 	by cust_id;
	r_point=r/&m_r;label r_point='R|Cg';
	f_point=f/&m_f;label f_point='F|Cg';
	m_point=m/&m_m;label m_point='M|Cg';
    rfm_pnt=sqrt(r_point*f_point*m_point);label rfm_pnt='RFM|Cg';
	format r_point f_point m_point rfm_pnt 8.3;
run;

/* ڋqf[^̓ */
data sugij.cust_dwh;
	merge sugij.master sum4 sum6 rfm;
	by cust_id;
run;
quit;